package olw.example.myequalizer;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.provider.BaseColumns;

public class EqualDBhelper extends SQLiteOpenHelper implements BaseColumns {
	
	private static final String DATABASE_NAME = "eqprofdb.db";
    private static final int DATABASE_VERSION = 2;
    private static final String DATABASE_TABLE = "profils";
    
    public static final String PROFIL_COLUMN = "profil";
    public static final String VOLUME_COLUMN = "vol_p";
    public static final String TREBLE_COLUMN = "tre_p";
    public static final String TRECENFRE_COLUMN = "trecf_p";
    public static final String MIDDLE_COLUMN = "mid_p";
    public static final String MIDQFAC_COLUMN = "midqf_p";
    public static final String BASS_COLUMN = "bass_p";
    public static final String LOWQFAC_COLUMN = "lowqf_p";
    public static final String LOUDNESS_COLUMN = "loud_p";
    public static final String LOUCENFRE_COLUMN = "loucf_p";
    public static final String HIGHBOOST_COLUMN = "hibo_p";
    public static final String SUBCUTFRE_COLUMN = "subcf_p";
    public static final String MIDCENFRE_COLUMN = "midcf_p";
    public static final String LOWCENFRE_COLUMN = "lowcf_p";
    public static final String BASSDC_COLUMN = "bassdc_p";
    public static final String RFATT_COLUMN = "rfatt_p";
    public static final String LFATT_COLUMN = "lfatt_p";
    public static final String RRATT_COLUMN = "rratt_p";
    public static final String LRATT_COLUMN = "lratt_p";
    public static final String SUBATT_COLUMN = "subatt_p";
    public static final String SUBEN_COLUMN = "suben_p";
    public static final String GAIN_COLUMN = "gain_p";
    public static final String INPSEL_COLUMN = "inp_p";
    public static final String MODE_COLUMN = "mode_p";
    
    private static final String DATABASE_CREATE_SCRIPT = "CREATE TABLE "
            + DATABASE_TABLE + " (" + BaseColumns._ID + " INTEGER PRIMARY KEY AUTOINCREMENT, " + PROFIL_COLUMN 
            + " text not null, " + VOLUME_COLUMN + " integer, " + TREBLE_COLUMN + " integer, " + TRECENFRE_COLUMN + " integer, " 
            + MIDDLE_COLUMN + " integer, " + MIDQFAC_COLUMN + " integer, " + BASS_COLUMN + " integer, " + LOWQFAC_COLUMN
            + " integer, " + LOUDNESS_COLUMN + " integer, " + LOUCENFRE_COLUMN + " integer, " + HIGHBOOST_COLUMN + " integer, "
            + SUBCUTFRE_COLUMN + " integer, " + MIDCENFRE_COLUMN + " integer, " + LOWCENFRE_COLUMN + " integer, " 
            + BASSDC_COLUMN + " integer, " + RFATT_COLUMN + " integer, " + LFATT_COLUMN + " integer, " + RRATT_COLUMN
            + " integer, " + LRATT_COLUMN + " integer, " + SUBATT_COLUMN + " integer, " + SUBEN_COLUMN + " integer, "
            + GAIN_COLUMN + " integer, " + INPSEL_COLUMN + " integer, " + MODE_COLUMN +" integer);";
    
    public EqualDBhelper(Context context) {
        super(context, DATABASE_NAME, null, DATABASE_VERSION); 
    }

	public EqualDBhelper(Context context, String name, SQLiteDatabase.CursorFactory factory,
			int version) {
		super(context, name, factory, version);
		// TODO Auto-generated constructor stub
	}
	

	@Override
	public void onCreate(SQLiteDatabase db) {
		// TODO Auto-generated method stub
		db.execSQL(DATABASE_CREATE_SCRIPT);
	}

	@Override
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
		// TODO Auto-generated method stub
		db.execSQL("DROP TABLE IF EXISTS " + "profils");
	    onCreate(db); 

	}
	
	//       ___________________________________________
	

}
