package olw.example.myequalizer;

import java.util.ArrayList;
import java.util.List;
import java.util.Timer;
import java.util.TimerTask;

import android.content.BroadcastReceiver;
import android.content.ContentValues;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteException;
import android.net.wifi.SupplicantState;
import android.net.wifi.WifiConfiguration;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.CompoundButton;
import android.widget.RadioGroup;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ToggleButton;
import android.support.v4.app.FragmentManager;


public class MyEqualizer extends ActionBarActivity {
	
	    //
	
	SeekBar volumeSeekBar, temhighSeekBar, temmidSeekBar, temlowSeekBar, loudSeekBar, subSeekBar;
	
	    //  
	
	private TextView parvolTextView, partemhighTextView, partemmidTextView, partemlowTextView, parloudTextView;
	private TextView parRFTextview, parLFTextview, parRRTextview, parLRTextview;
	private TextView pargainTextview, parsubTextview, modeTextview;

	
	    //
	
	RadioGroup trecenfreRadioGroup, midQfacRadioGroup, lowQfacRadioGroup, loucenfreRadioGroup, midcenfreRadioGroup;
	RadioGroup lowcenfreRadioGroup, lowdcRadioGroup, inpselRadioGroup, subcoRadioGroup;
	
	    //Toggle buttons
	
	ToggleButton boostToggleButton, subToggleButton;
	
        //	
	
	private TcpClient mTcpClient;          //   TcpClient
	//private DelaySendingMes delsendmes;
	//private Timer mTimer;
	private Timer actSerParTimer;          //     
	private ProcExecDelay sendProfTask;    //    
	private AdditionDialog additiondialog; //  "***"
	                                //         
	public ArrayList<String> profilsList;
	private ContentValues cv;
	private Cursor mc;
	private SQLiteDatabase prof_db;
	private EqualDBhelper mEqualDBhelper; //   EqualDBhelper
	
	                                //     
	private String target_SSID = "";                             //SSID   (  )
	public static final String EQUAL_PREFERENCES = "eqsettings"; //  
	public static final String EQUAL_PREFERENCES_SSID = "ssid";  //: SSID  ,    
	private SharedPreferences equalSettings;                     //  SharedPreferences
	
	                                //    WIFI
	private WifiManager wifiManager;
	private boolean wifi_conf_first_time = false; // true,  ,        SSID ,  
	                                              //   , ..     

	private WifiProfCreateDial wifiProfCreateDial;
	private FragmentManager wfm;
    private boolean extra_wifi_prof_recreate_need = false; //  ,           
                                                           //   : true - , false - 
	
	                           //       


    public boolean ending = true; // false,        ""    onStop
	
	private int selectableParam = 0;  //     
	private int dataParam = 0;        //  
	private int check_sum = 0;        //      "03"   (    )
	private boolean control_enable = false;  //   /
	private int volume = 16;          //  
	private int treble = 31;          //   ..
	private int treCenFre = 96;       //     ..
	private int middle = 16;          //   ..
	private int midQfac = 96;         //    Q-factor 
	private int bass = 20;            //   ..
	private int lowQfac = 0;          //    Q-factor 
	private int loudness = 15;        //   
	private int louCenFre = 16;       //     
	private int highboost = 64;       //    High Boost
	private int subCutFre = 3;        //         
	private int midCenFre = 8;        //     ..
	private int lowCenFre = 32;       //     ..
	private int bassDC = 64;          //   Bass DC Mode
	private int smoothing = 0;        //   Smoothing Filter
	private int rfatt = 16;           //       
	private int lfatt = 16;           //       
	private int rratt = 16;           //       
	private int lratt = 16;           //       
	private int subatt = 96;          //    
	private int sub_enable = 0;       //  : 0-, 1-
	private int gain = 24;            //     
	private int inpsel = 1;           //   
	private int mode = 2;             //      (2.0; pro; 4.1)
	private int mute = 1;             //  "MUTE" 1 - ; 2 - 
	
	private boolean dbwr_enable = true; //  (true)   (false)     ..
	public int restart_point = 0;  //    
	                      
	

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_my_equalizer);
		
		 // xml    java____________________________________
		
		volumeSeekBar = (SeekBar)findViewById(R.id.seekbar_volume);
		parvolTextView = (TextView)findViewById(R.id.textView_parvol);
		temhighSeekBar = (SeekBar)findViewById(R.id.seekbar_temhigh);
		partemhighTextView = (TextView)findViewById(R.id.textView_partemhigh);
		temmidSeekBar = (SeekBar)findViewById(R.id.seekbar_temmid);
		partemmidTextView = (TextView)findViewById(R.id.textView_partemmid);
		temlowSeekBar = (SeekBar)findViewById(R.id.seekbar_temlow);
		partemlowTextView = (TextView)findViewById(R.id.textView_partemlow);
		loudSeekBar = (SeekBar)findViewById(R.id.seekbar_loudness);
		parloudTextView = (TextView)findViewById(R.id.textView_parloud);
		parRFTextview = (TextView)findViewById(R.id.textView_rf_param);
		parLFTextview = (TextView)findViewById(R.id.textView_lf_param);
		parRRTextview = (TextView)findViewById(R.id.textView_rr_param);
		parLRTextview = (TextView)findViewById(R.id.textView_lr_param);
		pargainTextview = (TextView)findViewById(R.id.textView_gain_param);
		subSeekBar = (SeekBar)findViewById(R.id.seekbar_sub);
		parsubTextview = (TextView)findViewById(R.id.textView_parsub);
		modeTextview = (TextView)findViewById(R.id.textView_mode);
		
		trecenfreRadioGroup = (RadioGroup)findViewById(R.id.radioGroup_cenfreq_temhigh);
		midQfacRadioGroup = (RadioGroup)findViewById(R.id.radioGroup_qfac_temmid);
		lowQfacRadioGroup = (RadioGroup)findViewById(R.id.radioGroup_qfac_temlow);
		loucenfreRadioGroup = (RadioGroup)findViewById(R.id.radioGroup_cenfreq_loud);
		midcenfreRadioGroup = (RadioGroup)findViewById(R.id.radioGroup_cenfreq_temmid);
		lowcenfreRadioGroup = (RadioGroup)findViewById(R.id.radioGroup_cenfreq_temlow);
		lowdcRadioGroup = (RadioGroup)findViewById(R.id.radioGroup_modelow);
		inpselRadioGroup = (RadioGroup)findViewById(R.id.radioGroup_input_select);
		subcoRadioGroup = (RadioGroup)findViewById(R.id.radioGroup_sub_cutoff);
		
		boostToggleButton = (ToggleButton)findViewById(R.id.togglebutton_highboost);
		subToggleButton = (ToggleButton)findViewById(R.id.togglebutton_sub);
		
		 //   ______________________________________
		
		volumeSeekBar.setOnSeekBarChangeListener(volumeSeekBarChangeListener);
		temhighSeekBar.setOnSeekBarChangeListener(temhighSeekBarChangeListener);
		temmidSeekBar.setOnSeekBarChangeListener(temmidSeekBarChangeListener);
		temlowSeekBar.setOnSeekBarChangeListener(temlowSeekBarChangeListener);
		loudSeekBar.setOnSeekBarChangeListener(loudSeekBarChangeListener);
		subSeekBar.setOnSeekBarChangeListener(subSeekBarChangeListener);
		
		 //   ____________________________________
		
		trecenfreRadioGroup.setOnCheckedChangeListener(trecenfreRadioGroupOnCheckedChangeListener);
		midQfacRadioGroup.setOnCheckedChangeListener(midQfacRadioGroupOnCheckedChangeListener);
		lowQfacRadioGroup.setOnCheckedChangeListener(lowQfacRadioGroupOnCheckedChangeListener);
		loucenfreRadioGroup.setOnCheckedChangeListener(loucenfreRadioGroupOnCheckedChangeListener);
		midcenfreRadioGroup.setOnCheckedChangeListener(midcenfreRadioGroupOnCheckedChangeListener);
		lowcenfreRadioGroup.setOnCheckedChangeListener(lowcenfreRadioGroupOnCheckedChangeListener);
		lowdcRadioGroup.setOnCheckedChangeListener(lowdcRadioGroupOnCheckedChangeListener);
		inpselRadioGroup.setOnCheckedChangeListener(inpselRadioGroupOnCheckedChangeListener);
		subcoRadioGroup.setOnCheckedChangeListener(subcoRadioGroupOnCheckedChangeListener);
		
		 //   ToggleButton__________________________________
		
		boostToggleButton.setOnCheckedChangeListener(boostToggleButtonOnCheckedChangeListener);
		subToggleButton.setOnCheckedChangeListener(subToggleButtonOnCheckedChangeListener);
		
		parvolTextView.setText("   " + "mute");       //  TextView   
		partemhighTextView.setText("   " + "-15dB");  //  TextView    
		partemmidTextView.setText("   " + "-15dB");   //  TextView    
		partemlowTextView.setText("   " + "-15dB");   //  TextView    
		parloudTextView.setText("   " + "-15dB");     //  TextView  
		parRFTextview.setText(" " + Conv_dB(rfatt) + "dB");  // 
		parLFTextview.setText(" " + Conv_dB(lfatt) + "dB");  // TextView  
		parRRTextview.setText(" " + Conv_dB(rratt) + "dB");  //  
		parLRTextview.setText(" " + Conv_dB(lratt) + "dB");  // 
		pargainTextview.setText(" " + ConGain_dB(gain) + "dB"); //      
		parsubTextview.setText("   " + "mute");       //  TextView    
		
		//    
		
		equalSettings = getSharedPreferences(EQUAL_PREFERENCES, Context.MODE_PRIVATE);
		
		 //        (   )
		
		mEqualDBhelper = new EqualDBhelper(this, "eqprofdb.db", null, 2);
		profilsList = new ArrayList<String>();
		
		//   WIFI____________________________________________________
		
		wifiManager = (WifiManager) getSystemService(Context.WIFI_SERVICE);
		
		//this.registerReceiver(this.WifiStateChangedReceiver, new IntentFilter(WifiManager.WIFI_STATE_CHANGED_ACTION));
		//this.registerReceiver(this.SupplicantStateChangedActionReceiver, new IntentFilter(WifiManager.SUPPLICANT_STATE_CHANGED_ACTION));
		
		//   SSID  _________________________________
		if (equalSettings.contains(EQUAL_PREFERENCES_SSID)) {
			target_SSID = equalSettings.getString(EQUAL_PREFERENCES_SSID, ""); //     SSID  
			                         //  
			this.registerReceiver(this.WifiStateChangedReceiver, new IntentFilter(WifiManager.WIFI_STATE_CHANGED_ACTION));
		} else {                                                               //     SSID  
			     //   "       "  
			onWifiProfCreate(1); //     -  onStart      restart_point=1.
		}
		
	}
	
	     //    ___________________________________
	
	@Override
	protected void onStart() {
		super.onStart();
		if (restart_point == 1) { //      WIFI     
			ending = true;
		    restart_point = 0;
		    wifiProfCreateDial.dismiss();
		    wifi_conf_first_time = true;  //..      
			this.registerReceiver(this.WifiStateChangedReceiver, new IntentFilter(WifiManager.WIFI_STATE_CHANGED_ACTION));
		}
		if (restart_point == 2) { //      WIFI    
			restart_point = 0;
			ending = true;
			wifiProfCreateDial.dismiss();
			wifi_conf_first_time = false;  //..       
		}
		//new ConnectTask().execute();
		
	}
	
	@Override
	protected void onStop() {
		super.onStop();
		//finish();
		
		if(mTcpClient != null) {
			//disconnect
			mTcpClient.stopClient();
			mTcpClient = null;
		}
		
	}
	/*
	@Override
	protected void onDestroy() {
		super.onDestroy();
		Killing_proc();
		finish();
	}
    */
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.my_equalizer, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		int id = item.getItemId();
		if (id == R.id.action_settings) {
			return true;
		}
		return super.onOptionsItemSelected(item);
	}
	/*
	@Override
	public void onBackPressed() { //    
		// TODO Auto-generated method stub
		super.onBackPressed();
		if (ending) {finish();}
	}
	*/
	//      
	/*
	private void Killing_proc() {
		if(mTcpClient != null) {mTcpClient.stopClient(); mTcpClient = null;}
		unregisterReceiver(SupplicantStateChangedActionReceiver);
		unregisterReceiver(WifiStateChangedReceiver);
		wifiManager = null;
		if (actSerParTimer != null) {actSerParTimer.cancel(); actSerParTimer = null;}
		if (sendProfTask != null) {sendProfTask.cancel(); sendProfTask = null;}
		if (additiondialog != null) {additiondialog.onDestroy();}
		Profdb_canceled();
		mEqualDBhelper = null;
		if (wifiProfCreateDial != null) {wifiProfCreateDial.onDestroy();}
		if (wfm != null) {wfm = null;}	
	}
	*/
	                 //           
	
	//     .   -  onStart      restart_point.
	
	private void onWifiProfCreate(int restartpoint) {
		wfm = getSupportFragmentManager();
		wifiProfCreateDial = new WifiProfCreateDial(restartpoint);
		wifiProfCreateDial.setCancelable(false);
		wifiProfCreateDial.show(wfm, "wifi_prof_create");
	}
	
	//    __________________________________________________________
	
	public void Demo_start() {
		new ConnectTask().execute();        // 
	}
	
	//     WIFI
	
	public void onWifiSettings_completed() {
		wifi_conf_first_time = true;  //..      
		this.registerReceiver(this.WifiStateChangedReceiver, new IntentFilter(WifiManager.WIFI_STATE_CHANGED_ACTION));
	}
	
	//      SSID________________________
	
	public void Wifiprof_confirm() {
		//wifiProfCreateDial.dismiss();
		SharedPreferences.Editor editor = equalSettings.edit(); //  SSID
	    editor.putString(EQUAL_PREFERENCES_SSID, target_SSID);
	    editor.commit();
	    wifi_conf_first_time = false;  //    
		new ConnectTask().execute();   //  
	}
	
	//    __________________________________
	
	public void onRestore_wifiprof() {
		onWifiProfCreate(2);
	}
	
	//   ______________________________________________
	
	public void onRecreate_wifiprof() {
		unregisterReceiver(SupplicantStateChangedActionReceiver);
		unregisterReceiver(WifiStateChangedReceiver);
		onWifiProfCreate(1);
	}
	
	//         ___________
	
	public void onSecond_Demo() {
		unregisterReceiver(SupplicantStateChangedActionReceiver);
		unregisterReceiver(WifiStateChangedReceiver);
		new ConnectTask().execute();
	}
	
	//  ________________________________________________________-----------------------------------------
	
	public void onApp_reload() {
		Intent appintent = getIntent();
        finish();
        startActivity(appintent);
	}
	
	//    ,     
	
	private void Recreate_wifi_prof() {
		FragmentManager wrcfm = getSupportFragmentManager();
	    WifiProfRECreateDial wifiProfRECreateDial = new WifiProfRECreateDial();
		wifiProfRECreateDial.setCancelable(false);
		wifiProfRECreateDial.show(wrcfm, "wifi_prof_recreate");
	}
	
	//  ,              
	
	private void Extra_recreate_wifi_prof() {
		Timer etimer = new Timer();               //    
	    TimerTask delay_recreate = new TimerTask() {

		    @Override
		    public void run() {
			    // TODO Auto-generated method stub
			    runOnUiThread(new Runnable() {
			    	
				    @Override
				    public void run() {  //   
				    	if (extra_wifi_prof_recreate_need) {extra_wifi_prof_recreate_need = false; Recreate_wifi_prof();}
				    }
			    });
		    }
	    };
	    //if (timer != null) {timer.cancel();}
	    etimer.schedule(delay_recreate, 20000);
	}
	
	                        //      
	
	//           _____________________
	
	private void Temhigh_Sending() {
		int trebledata = 0;
		trebledata = treble + treCenFre + 128;          //   ,    D7  
		mTcpClient.sendMessage("2" + trebledata);       //    ,    D7  	
	}
	
	//     C   Q-factor____________________________________
	
	private void Temmid_Sending() {
		int middledata = 0;
		middledata = middle + midQfac;                   //    ,  Q-factor,  
		if (middledata < 10) {
		    mTcpClient.sendMessage("300" + middledata);  //     ,  Q-factor,   
		}                                                // (   ,    )
			
		if ((middledata >= 10) && (middledata < 100)) {
			mTcpClient.sendMessage("30" + middledata);   //     ,  Q-factor, 
		}                                                // (   ,   )
			
		if (middledata >= 100) {
			mTcpClient.sendMessage("3" + middledata);    //     ,  Q-factor,   
		}                                                // (   ,  )   
				
	}
	
	//     C   Q-factor____________________________________
	
	private void Temlow_Sending() {
		int bassdata = 0;
		bassdata = bass + lowQfac;                       //    ,  Q-factor,  
		if (bassdata < 10) {
		    mTcpClient.sendMessage("400" + bassdata);    //     ,  Q-factor,   
		}                                                // (   ,    )
		
		if ((bassdata >= 10) && (bassdata < 100)) {
			mTcpClient.sendMessage("40" + bassdata);     //     ,  Q-factor, 
		}                                                // (   ,   )
		
		if (bassdata >= 100) {
		    mTcpClient.sendMessage("4" + bassdata);      //     ,  Q-factor,   
		}                                                // (   ,  )
	}
	
	//       ___________________________________
	
	private void Loud_Sending() {
		int loudnessdata = 0;
		loudnessdata = loudness + louCenFre + highboost; //   ,     High Boost  
		if (loudnessdata < 10) {
		    mTcpClient.sendMessage("500" + loudnessdata); //    ,      
		}                                   //High Boost   (   ,    )
		
		if ((loudnessdata >= 10) && (loudnessdata < 100)) {
			mTcpClient.sendMessage("50" + loudnessdata);//    ,     
		}                                   //High Boost   (   ,   )
		
		if (loudnessdata >= 100) {
		    mTcpClient.sendMessage("5" + loudnessdata); //    ,      
		}                                   //High Boost   (   ,  )
	}
	
	//    :       ,     , Bass DC Mode,
	//Smoothing Filter
	
	private void Misc_Sending() {
		int miscdata = 0;
		miscdata = subCutFre + midCenFre + lowCenFre + bassDC + smoothing; //     
		if (miscdata < 10) {
		    mTcpClient.sendMessage("600" + miscdata); //        
		}                                             //(   ,    )
		
		if ((miscdata >= 10) && (miscdata < 100)) {
			mTcpClient.sendMessage("60" + miscdata);  //       
		}                                             //(   ,   )
		
		if (miscdata >= 100) {
		    mTcpClient.sendMessage("6" + miscdata);   //        
		}                                             //(   ,  )
	}
	
	//     att_chand  _________________
	
	private int Att_Dec(int att_chand) {
		int resd = 0;
		if (att_chand < 16) {
		    resd = att_chand - 1;
		    if (resd == 0) {resd = 16;}
		} else {resd = att_chand + 1;}
		return resd;
	}
	
	//     att_chani  _________________
	
	private int Att_Inc(int att_chani) {
		int resi = 0;
		if (att_chani < 16) {
			resi = att_chani + 1;
		} else {
			resi = att_chani - 1;
			if (resi == 15) {resi = 1;}
		}
		return resi;
	}
	
	//     att_conv     
	
	private int Conv_dB(int att_conv) {
		int resc = 0;
		if (att_conv >= 16) {
			resc = 16 - att_conv;
		} else {resc = att_conv;}
		return resc;
	}
	
	//       gain_conv   
	
	private int ConGain_dB(int gain_conv) {
		int resg = 0;
		resg = gain_conv / 8;
		return resg;
	}
	
	//     (att_dt)       prefix
	
	private void Att_Sending(int prefix, int att_dt) {
		if (att_dt < 10) {                          
			mTcpClient.sendMessage((prefix + "0") + att_dt); //     (  
		} else {                                             //,   )
		    mTcpClient.sendMessage((prefix + "") + att_dt);  //     (  )
		}
	}
	
	//          ______
	
	private void Input_Sending() {
		int gaindata = 0;
		gaindata = gain + inpsel;
		if (gaindata < 10) {
		    mTcpClient.sendMessage("700" + gaindata); //           
		}                                             //(   ,    )
		
		if ((gaindata >= 10) && (gaindata < 100)) {
			mTcpClient.sendMessage("70" + gaindata);  //          
		}                                             //(   ,   )
		
		if (gaindata >= 100) {
		    mTcpClient.sendMessage("7" + gaindata);   //           
		}                                             //(   ,  )
	}
	
	//     inpselRadioGroup (   )   
	//        ,     (inpsel  1)  
	
	private void Inp_Default() {
		if (inpselRadioGroup.getVisibility() == RadioGroup.INVISIBLE) {
			inpselRadioGroup.setVisibility(RadioGroup.VISIBLE);
		}
	}
	
	//         
	//(    ""     "MODE")
	
	private void Mode_Display() {
		switch(mode) { 
		case 1:                
			Inp_Default();
			modeTextview.setText("  2.0  ");
			break;
			
		case 2:
			Inp_Default();
			modeTextview.setText("  pro  ");
			break;
			
		case 3:
			if (inpselRadioGroup.getVisibility() == RadioGroup.VISIBLE) {
				inpselRadioGroup.setVisibility(RadioGroup.INVISIBLE);
			}
			modeTextview.setText("  4.1  ");
			break;	
		}	
	}
	
	//     "MUTE"     mute__
	/*
	private void Mute_Show() {
	    //    "MUTE"
			AlertDialog.Builder mutebuilder = new AlertDialog.Builder(MyEqualizer.this);
			mutebuilder.setTitle("MUTE...");
	        mutebuilder.setCancelable(true);
	        mutebuilder.setPositiveButton("MUTE OFF", new DialogInterface.OnClickListener() {
	        	
				@Override
				public void onClick(DialogInterface dialog, int which) {
					// TODO Auto-generated method stub
					dialog.cancel();
					mute = 1;
				}
			});
	        
	        AlertDialog muteDialog = mutebuilder.create();
			muteDialog.show();
			mute = 2;
	}
	*/
	
	//     "MUTE"     mute__
	
	private void Mute_Show() {
		mute = 2;
		FragmentManager fm = getSupportFragmentManager();
        MuteDialog mutedialog = new MuteDialog();
        mutedialog.setCancelable(false);
        mutedialog.show(fm, "mute_layout");
        
	}
	
	//   mute      (  mutedialog)
	
	public void onMuteOff() {
		mute = 1;
		mTcpClient.sendMessage("17" + mute);
	}
	
	                        //    ,  ..      .
	
	//     "***"      
	
	private void Add_Show() {
		
	                            //    
	    profilsList.clear();    //      
	    if (cv != null) {cv = null;}    //   ContentValues    
	    cv = new ContentValues(); 
	    try {
	    	prof_db = mEqualDBhelper.getWritableDatabase(); // (  )    
	    	dbwr_enable = true;                             //       
	    }
	    catch (SQLiteException ex){  //   
	    	prof_db = mEqualDBhelper.getReadableDatabase(); //       
	    	dbwr_enable = false;                            //       
	    } 
	              //      (  ).  :
	              //      profils,  Cursor
	    mc = prof_db.query("profils", null, null, null, null, null, null);
	    
	    if (mc.moveToFirst()) { //  
	    	do {
	    		profilsList.add(mc.getString(mc.getColumnIndex(EqualDBhelper.PROFIL_COLUMN)));
	    	} while(mc.moveToNext()); // Cursor      
	    } else { //  
	    	profilsList.add(" ");
	    }
	        // 
	    FragmentManager afm = getSupportFragmentManager();
	    additiondialog = new AdditionDialog();
	    additiondialog.setCancelable(false);
	    additiondialog.show(afm, "additiondialog");
	}
	
	//      _____________________________________________
	
	private void Profdb_canceled() {
		if (mc != null) {mc.close();} //  cursor
		if (cv != null) {cv = null;} // ContentValues 
		mEqualDBhelper.close();      //   
		profilsList.clear();         //    
	}
	
	//          (  additiondialog)
	
	public void onSaveDef() {
		mTcpClient.sendMessage("04");
		Profdb_canceled();           //   
	}
	
	//      (  additiondialog)________
	
	public void onResDef() {
		mTcpClient.sendMessage("05");
		Profdb_canceled();           //   
	}
	
	//        (  additiondialog)______
	
	public void onProf_conf(String profil) {
		if (dbwr_enable) {
			//String profil = additiondialog.etprof_create.getText().toString(); //       
			                                                                   //   
			cv.put(EqualDBhelper.PROFIL_COLUMN, profil);
			cv.put(EqualDBhelper.VOLUME_COLUMN, volume);
			cv.put(EqualDBhelper.TREBLE_COLUMN, treble);
			cv.put(EqualDBhelper.TRECENFRE_COLUMN, treCenFre);
			cv.put(EqualDBhelper.MIDDLE_COLUMN, middle);
			cv.put(EqualDBhelper.MIDQFAC_COLUMN, midQfac);
			cv.put(EqualDBhelper.BASS_COLUMN, bass);
			cv.put(EqualDBhelper.LOWQFAC_COLUMN, lowQfac);
			cv.put(EqualDBhelper.LOUDNESS_COLUMN, loudness);
			cv.put(EqualDBhelper.LOUCENFRE_COLUMN, louCenFre);
			cv.put(EqualDBhelper.HIGHBOOST_COLUMN, highboost);
			cv.put(EqualDBhelper.SUBCUTFRE_COLUMN, subCutFre);
			cv.put(EqualDBhelper.MIDCENFRE_COLUMN, midCenFre);
			cv.put(EqualDBhelper.LOWCENFRE_COLUMN, lowCenFre);
			cv.put(EqualDBhelper.BASSDC_COLUMN, bassDC);
			cv.put(EqualDBhelper.RFATT_COLUMN, rfatt);
			cv.put(EqualDBhelper.LFATT_COLUMN, lfatt);
			cv.put(EqualDBhelper.RRATT_COLUMN, rratt);
			cv.put(EqualDBhelper.LRATT_COLUMN, lratt);
			cv.put(EqualDBhelper.SUBATT_COLUMN, subatt);
			cv.put(EqualDBhelper.SUBEN_COLUMN, sub_enable);
			cv.put(EqualDBhelper.GAIN_COLUMN, gain);
			cv.put(EqualDBhelper.INPSEL_COLUMN, inpsel);
			cv.put(EqualDBhelper.MODE_COLUMN, mode);
			prof_db.insert("profils", null, cv);
			Profdb_canceled();           //   
			Toast toast = Toast.makeText(getApplicationContext(), "   !", Toast.LENGTH_SHORT); 
			toast.show();
		} else {
			Toast toast = Toast.makeText(getApplicationContext(), " !", Toast.LENGTH_SHORT); 
			toast.show();
		}
	}
	
	
	//      (  additiondialog)_____________________
	
	public void onProf_del(String del_prof) {
		if (mc.getCount() > 0) {     //    
		    //String d_id = mc.getString(mc.getColumnIndex(EqualDBhelper._ID)); // id     
            
			prof_db.delete("profils", EqualDBhelper.PROFIL_COLUMN + " LIKE '" + del_prof + "'", null);	
		} else {
			Toast toast = Toast.makeText(getApplicationContext(), " !", Toast.LENGTH_SHORT); 
			toast.show();
		}
		Profdb_canceled();           //   
	}
	
	//    "***"
	
	public void onProf_exit() {
		Profdb_canceled();           //   
	}
	
	//        ______
	
    public class ProcExecDelay extends TimerTask {
    	
        private int num_task = 0;

		@Override
		public void run() {

			runOnUiThread(new Runnable() {

				@Override
				public void run() {
					num_task++;
					Toast toast = Toast.makeText(getApplicationContext(), "...", Toast.LENGTH_SHORT); 
					toast.show();
					Param_Sending(num_task);
				}
			});
		}
	}
    
    //        _______
    
    public void Param_Sending(int number) {
    	switch(number) {
    	case 1: 
    		Input_Sending();
    		break;
    	case 2:
    		mTcpClient.sendMessage("16" + mode);
    		break;
    	case 3:
    		if (sub_enable == 0) {mTcpClient.sendMessage("8255");} else {mTcpClient.sendMessage("8247");}
    		break;
    	case 4:
    		Loud_Sending();
    		break;
    	case 5:
    		Temhigh_Sending();
    		break;
    	case 6:
    		Temmid_Sending();
    		break;
    	case 7:
    		Temlow_Sending();
    		break;
    	case 8:
    		Misc_Sending();
    		break;
    	case 9:
    		Att_Sending(11, rfatt);
    		break;
    	case 10:
    		Att_Sending(12, lfatt);
    		break;
    	case 11:
    		Att_Sending(13, rratt);
    		break;
    	case 12:
    		Att_Sending(14, lratt);
    		break;
    	case 13:
    		Att_Sending(15, subatt);
    		break;
    	case 14:
    		Att_Sending(10, volume);
    		break;
    	case 15:	
    		if (actSerParTimer != null) { 
    	    	actSerParTimer.cancel();
    	    	actSerParTimer.purge();
    	    	actSerParTimer = null;
    		}
    		Toast toast = Toast.makeText(getApplicationContext(), " !", Toast.LENGTH_SHORT); 
			toast.show();
    		break;
    	}
    }
    
    //      (  additiondialog)__________
    
    public void onProf_activation(String prof_act) {
    	if (mc.getCount() > 0) {     //    
    		mc.close();
    		String[] selectionArgs = new String[] { prof_act };
    		mc = prof_db.query("profils", null, "profil LIKE ?", selectionArgs, null, null, null);
    		mc.moveToFirst();
    		mTcpClient.sending_enable = true;
    	    onSetInterface(10, 96);  //        .   
    	    mTcpClient.sending_enable = false; //  , ,   
    	    volume = mc.getInt(mc.getColumnIndex(EqualDBhelper.VOLUME_COLUMN));
    	    rfatt = mc.getInt(mc.getColumnIndex(EqualDBhelper.RFATT_COLUMN));
    	    lfatt = mc.getInt(mc.getColumnIndex(EqualDBhelper.LFATT_COLUMN));
    	    rratt = mc.getInt(mc.getColumnIndex(EqualDBhelper.RRATT_COLUMN));
    	    lratt = mc.getInt(mc.getColumnIndex(EqualDBhelper.LRATT_COLUMN));
    	    subatt = mc.getInt(mc.getColumnIndex(EqualDBhelper.SUBATT_COLUMN));
    	    mode = mc.getInt(mc.getColumnIndex(EqualDBhelper.MODE_COLUMN));
    	    treble = mc.getInt(mc.getColumnIndex(EqualDBhelper.TREBLE_COLUMN));
    	    treCenFre = mc.getInt(mc.getColumnIndex(EqualDBhelper.TRECENFRE_COLUMN));
    	    middle = mc.getInt(mc.getColumnIndex(EqualDBhelper.MIDDLE_COLUMN));
    	    midQfac = mc.getInt(mc.getColumnIndex(EqualDBhelper.MIDQFAC_COLUMN));
    	    bass = mc.getInt(mc.getColumnIndex(EqualDBhelper.BASS_COLUMN));
    	    lowQfac = mc.getInt(mc.getColumnIndex(EqualDBhelper.LOWQFAC_COLUMN));
    	    loudness = mc.getInt(mc.getColumnIndex(EqualDBhelper.LOUDNESS_COLUMN));
    	    louCenFre = mc.getInt(mc.getColumnIndex(EqualDBhelper.LOUCENFRE_COLUMN));
    	    highboost = mc.getInt(mc.getColumnIndex(EqualDBhelper.HIGHBOOST_COLUMN));
    	    subCutFre = mc.getInt(mc.getColumnIndex(EqualDBhelper.SUBCUTFRE_COLUMN));
    	    midCenFre = mc.getInt(mc.getColumnIndex(EqualDBhelper.MIDCENFRE_COLUMN));
    	    lowCenFre = mc.getInt(mc.getColumnIndex(EqualDBhelper.LOWCENFRE_COLUMN));
    	    bassDC = mc.getInt(mc.getColumnIndex(EqualDBhelper.BASSDC_COLUMN));
    	    inpsel = mc.getInt(mc.getColumnIndex(EqualDBhelper.INPSEL_COLUMN));
    	    gain = mc.getInt(mc.getColumnIndex(EqualDBhelper.GAIN_COLUMN));
    	    sub_enable = mc.getInt(mc.getColumnIndex(EqualDBhelper.SUBEN_COLUMN));
    	    Profdb_canceled();           //    
    	    onSetInterface(10, volume);
    	    onSetInterface(11, rfatt);
    	    onSetInterface(12, lfatt);
    	    onSetInterface(13, rratt);
    	    onSetInterface(14, lratt);
    	    onSetInterface(15, subatt);
    	    onSetInterface(16, mode);
    	    onSetInterface(20, treble + treCenFre + 128);
    	    onSetInterface(30, middle + midQfac);
    	    onSetInterface(40, bass + lowQfac);
    	    onSetInterface(50, loudness + louCenFre + highboost);
    	    onSetInterface(60, subCutFre + midCenFre + lowCenFre + bassDC + smoothing);
    	    onSetInterface(70, inpsel + gain);
    	    if (sub_enable == 0) {onSetInterface(80, 255);} else {onSetInterface(80, 247);}
    	    mTcpClient.sending_enable = true;    	    
    	       	                            //       
    	    if (actSerParTimer != null) { //     "TimerTask is scheduled already"
    	    	actSerParTimer.cancel();
    	    	actSerParTimer = null;
    		}
    	    actSerParTimer = new Timer();       
    	    sendProfTask = new ProcExecDelay();
    	    actSerParTimer.schedule(sendProfTask, 500, 500);                        
    	} else {
    		Toast toast = Toast.makeText(getApplicationContext(), " !", Toast.LENGTH_SHORT); 
			toast.show();
    	}
    }
    
	
	//       _____________________________
	
	public class DelaySendingMes extends TimerTask {
		
		public String dmessage;

		@Override
		public void run() {

			runOnUiThread(new Runnable() {

				@Override
				public void run() {
					mTcpClient.sendMessage(dmessage);
				}
			});
		}	
	}
	
	//      
	
	private void Delay_sending(String istring, int idelay_ms) {
		/*
		if (mTimer != null) { //     "TimerTask is scheduled already"
			mTimer.cancel();
			mTimer = null;
		}
		*/
		Timer mTimer = new Timer();
		DelaySendingMes delsendmes = new DelaySendingMes();
		delsendmes.dmessage = istring;
		mTimer.schedule(delsendmes, idelay_ms);
	}
	
	//     ___________________________________
	
	public void onSetInterface(int selectableParam, int dataParam){
		if (selectableParam == 10) { //  
    		volume = dataParam;
       		if (dataParam >= 16) {
    			volumeSeekBar.setProgress(96 - dataParam);       //  
    			if (dataParam == 96) {
    				parvolTextView.setText("   " + "mute");      //  TextView (   0)
    			} else {
    			    parvolTextView.setText("   " + (16 - dataParam) + "dB"); //  TextView
    			}
    		} else {
    			volumeSeekBar.setProgress(80 + dataParam);       //  
    			parvolTextView.setText("   " + dataParam + "dB");//  TextView
    		}
    	}
    	if (selectableParam == 11) { //     
    		rfatt = dataParam;                                   //    
    		parRFTextview.setText(" " + Conv_dB(rfatt) + "dB");  //  Textview
    	}
        if (selectableParam == 12) { //     
        	lfatt = dataParam;                                   //    
    		parLFTextview.setText(" " + Conv_dB(lfatt) + "dB");  //  Textview
    	}
        if (selectableParam == 13) { //     
        	rratt = dataParam;                                   //    
    		parRRTextview.setText(" " + Conv_dB(rratt) + "dB");  //  Textview
    	}
        if (selectableParam == 14) { //     
        	lratt = dataParam;                                   //    
    		parLRTextview.setText(" " + Conv_dB(lratt) + "dB");  //  Textview
        }
        if (selectableParam == 15) { //     
        	subatt = dataParam;
        	if (dataParam >= 16) {
    			subSeekBar.setProgress(96 - dataParam);          //  
    			if (dataParam == 96) {
    				parsubTextview.setText("   " + "mute");      //  TextView (   0)
    			} else {
    			    parsubTextview.setText("   " + (16 - dataParam) + "dB"); //  TextView
    			}
    		} else {
    			subSeekBar.setProgress(80 + dataParam);          //  
    			parsubTextview.setText("   " + dataParam + "dB");//  TextView
    		}
        }
        if (selectableParam == 16) { //      (2.0; pro; 4.1)
        	mode = dataParam;
        	if (mode == 3) {
    			inpsel = 1;
    			inpselRadioGroup.check(R.id.bt_inp2);
    		}
        	Mode_Display();
        }
        if (selectableParam == 17) { //    "MUTE"
        	mute = dataParam;
        	if (mute == 2) {Mute_Show();}
        }
    	if (selectableParam == 20) { //   ..
    		dataParam = dataParam - 128;            // D7 
    		if (dataParam < 32) {
    			trecenfreRadioGroup.check(R.id.bt_cf_10);       //    
    			treCenFre = 0;
    		}
    		if (dataParam >= 96) {
    			trecenfreRadioGroup.check(R.id.bt_cf_17);       //  " "    
    			dataParam = dataParam - 96;         //  
    			treCenFre = 96;                     //    
    		}
            if (dataParam >= 64) {
            	trecenfreRadioGroup.check(R.id.bt_cf_15);
            	dataParam = dataParam - 64;
            	treCenFre = 64;                     //    
    		}
            if (dataParam >= 32) {
            	trecenfreRadioGroup.check(R.id.bt_cf_12);
            	dataParam = dataParam - 32;
            	treCenFre = 32;                     //    
    		}
            treble = dataParam;
            if (dataParam >= 16) {
            	temhighSeekBar.setProgress(dataParam - 1);                   //  
            	partemhighTextView.setText("   " + (dataParam - 16) + "dB"); //  TextView
            } else {
            	temhighSeekBar.setProgress(15 - dataParam);                  //  
            	partemhighTextView.setText("   " + (0 - dataParam) + "dB");  //  TextView
            }
    	}
    	if (selectableParam == 30) { //   ..
    		if (dataParam < 32) {
    			midQfacRadioGroup.check(R.id.bt_qmf_05);       //   Q- 
    			midQfac = 0;
    		}
    		if (dataParam >= 96) {
    			midQfacRadioGroup.check(R.id.bt_qmf_125); //  "Q- C"     
    			dataParam = dataParam - 96;         //  
    			midQfac = 96;                       //   Q- 
    		}
            if (dataParam >= 64) {
            	midQfacRadioGroup.check(R.id.bt_qmf_1);
            	dataParam = dataParam - 64;
            	midQfac = 64;                       //   Q- 
    		}
            if (dataParam >= 32) {
            	midQfacRadioGroup.check(R.id.bt_qmf_075);
            	dataParam = dataParam - 32;
            	midQfac = 32;                       //   Q- 
    		}
            middle = dataParam;
            if (dataParam >= 16) {
            	temmidSeekBar.setProgress(dataParam - 1);                   //  
            	partemmidTextView.setText("   " + (dataParam - 16) + "dB"); //  TextView
            } else {
            	temmidSeekBar.setProgress(15 - dataParam);                  //  
            	partemmidTextView.setText("   " + (0 - dataParam) + "dB");  //  TextView
            }
    	}
    	if (selectableParam == 40) { //   ..
    		if (dataParam < 32) {
    			lowQfacRadioGroup.check(R.id.bt_qlf_1);       //   Q- 
    			lowQfac = 0;
    		}
    		if (dataParam >= 96) {
    			lowQfacRadioGroup.check(R.id.bt_qlf_2); //  "Q- "     
    			dataParam = dataParam - 96;         //  
    			lowQfac = 96;                       //   Q- 
    		}
            if (dataParam >= 64) {
            	lowQfacRadioGroup.check(R.id.bt_qlf_15);
            	dataParam = dataParam - 64;
            	lowQfac = 64;                       //   Q- 
    		}
            if (dataParam >= 32) {
            	lowQfacRadioGroup.check(R.id.bt_qlf_125);
            	dataParam = dataParam - 32;
            	lowQfac = 32;                       //   Q- 
    		}
            bass = dataParam;
            if (dataParam >= 16) {
            	temlowSeekBar.setProgress(dataParam - 1);                   //  
            	partemlowTextView.setText("   " + (dataParam - 16) + "dB"); //  TextView
            } else {
            	temlowSeekBar.setProgress(15 - dataParam);                  //  
            	partemlowTextView.setText("   " + (0 - dataParam) + "dB");  //  TextView
            }
    	}
    	if (selectableParam == 50) { //  
    		if (dataParam >= 64) {
    			boostToggleButton.setChecked(false); //   High Boost    
    			dataParam = dataParam - 64;          //  +  
    			highboost = 64;                      //   High Boost
    		} else {
    			boostToggleButton.setChecked(true);
    			highboost = 0;
    		}
    		if (dataParam < 16) {
    			loucenfreRadioGroup.check(R.id.bt_cldf_flat);//     
    			louCenFre = 0;
    		}
            if (dataParam >= 48) {
            	loucenfreRadioGroup.check(R.id.bt_cldf_2400);
            	dataParam = dataParam - 48;
            	louCenFre = 48;                       //   
    		}
            if (dataParam >= 32) {
            	loucenfreRadioGroup.check(R.id.bt_cldf_800);
            	dataParam = dataParam - 32;
            	louCenFre = 32;                       //   
    		}
            if (dataParam >= 16) {
            	loucenfreRadioGroup.check(R.id.bt_cldf_400);
            	dataParam = dataParam - 16;
            	louCenFre = 16;                       //   
    		}
            loudness = dataParam;
            loudSeekBar.setProgress(15 - dataParam);                 //  
            parloudTextView.setText("   " + (0 - dataParam) + "dB"); //  TextView
    	}
    	if (selectableParam == 60) { //   :      
    		                         //,     , Bass DC Mode, Smoothing Filter
    		if (dataParam >= 128) {                   //Smoothing Filter off
    			dataParam = dataParam - 128;          //  Smoothing Filter off
    		}
    		if (dataParam >= 64) {                    //Bass DC Mode off
    			lowdcRadioGroup.check(R.id.bas_mod_normal);
    			dataParam = dataParam - 64;           //  Bass DC Mode off
    			bassDC = 64;                          //   Bass DC Mode
    		} else {
    			lowdcRadioGroup.check(R.id.bas_mod_DC);
    			bassDC = 0;                           //   Bass DC Mode
    		}
    		if (dataParam < 16) {
    			lowcenfreRadioGroup.check(R.id.bt_clf_60);
    			lowCenFre = 0;                        //    
    		}
    		if (dataParam >= 48) {
            	lowcenfreRadioGroup.check(R.id.bt_clf_200);
            	dataParam = dataParam - 48;           //     
            	lowCenFre = 48;                       //    
    		}
    		if (dataParam >= 32) {
            	lowcenfreRadioGroup.check(R.id.bt_clf_100);
            	dataParam = dataParam - 32;           //     
            	lowCenFre = 32;                       //    
    		}
    		if (dataParam >= 16) {
            	lowcenfreRadioGroup.check(R.id.bt_clf_80);
            	dataParam = dataParam - 16;           //     
            	lowCenFre = 16;                       //    
    		}
    		if (dataParam < 4) {
    			midcenfreRadioGroup.check(R.id.bt_cmf_500);
    			midCenFre = 0;                        //    
    		}
    		if (dataParam >= 12) {
            	midcenfreRadioGroup.check(R.id.bt_cmf_2500);
            	dataParam = dataParam - 12;           //     
            	midCenFre = 12;                       //    
    		}
    		if (dataParam >= 8) {
            	midcenfreRadioGroup.check(R.id.bt_cmf_1500);
            	dataParam = dataParam - 8;            //     
            	midCenFre = 8;                        //    
    		}
    		if (dataParam >= 4) {
            	midcenfreRadioGroup.check(R.id.bt_cmf_1000);
            	dataParam = dataParam - 4;            //     
            	midCenFre = 4;                        //    
    		}
    		switch(dataParam) {
			case 0:
				subcoRadioGroup.check(R.id.bt_sco_flat);
				subCutFre = 0;
				break;
			
			case 1:
				subcoRadioGroup.check(R.id.bt_sco_80);
				subCutFre = 1;
				break;
				
			case 2:
				subcoRadioGroup.check(R.id.bt_sco_120);
				subCutFre = 2;
				break;
				
			case 3:
				subcoRadioGroup.check(R.id.bt_sco_160);
				subCutFre = 3;
				break;
				
			default:
				break;
    		}
    	}
    	if (selectableParam == 70) { //        
    		gain = 8 * (dataParam >> 3);
    		inpsel = dataParam - gain;
    		pargainTextview.setText(" " + ConGain_dB(gain) + "dB");
    		switch(inpsel) {
    		case 0:
    			inpselRadioGroup.check(R.id.bt_inp1);
    			break;
    		
    		case 1:
    			inpselRadioGroup.check(R.id.bt_inp2);
    			break;
    			
    		case 2:
    			inpselRadioGroup.check(R.id.bt_inp3);
    			break;
    			
    		case 3:
    			inpselRadioGroup.check(R.id.bt_inp4);
    			break;
    		}
    	}
    	if (selectableParam == 80) { //   subwoofer on/off
    		if (dataParam == 255) {
    			sub_enable = 0;
    			subToggleButton.setChecked(false);
    		} else {
    			sub_enable = 1;
    			subToggleButton.setChecked(true);
    		}
    	}
	}
	
	//    :  ___________________________________
	
    public class ConnectTask extends AsyncTask<String, String, TcpClient> {
    	
    	@Override
        protected TcpClient doInBackground(String... message) {

            //we create a TCPClient object and
            mTcpClient = new TcpClient(new TcpClient.OnMessageReceived() {
                @Override
                //here the messageReceived method is implemented
                public void messageReceived(String message) {
                    //this method calls the onProgressUpdate
                    publishProgress(message);
                }
            });
            mTcpClient.run();

            return null;
        }

        @Override
        protected void onProgressUpdate(String... values) {
            super.onProgressUpdate(values);
            
            if (values[0].length() > 5) { //        
            	Toast toast = Toast.makeText(getApplicationContext(), "...", Toast.LENGTH_SHORT); 
    			toast.show();
    			mTcpClient.sending_enable = false;
            	onSetInterface(80, Integer.parseInt(values[0].substring(0, 3)));
            	onSetInterface(70, Integer.parseInt(values[0].substring(3, 6)));
            	onSetInterface(60, Integer.parseInt(values[0].substring(6, 9)));
            	onSetInterface(50, Integer.parseInt(values[0].substring(9, 12)));
            	onSetInterface(40, Integer.parseInt(values[0].substring(12, 15)));
            	onSetInterface(30, Integer.parseInt(values[0].substring(15, 18)));
            	onSetInterface(20, Integer.parseInt(values[0].substring(18, 21)));
            	onSetInterface(17, Integer.parseInt(values[0].substring(21, 24)));
            	onSetInterface(16, Integer.parseInt(values[0].substring(24, 27)));
            	onSetInterface(15, Integer.parseInt(values[0].substring(27, 30)));
            	onSetInterface(14, Integer.parseInt(values[0].substring(30, 33)));
            	onSetInterface(13, Integer.parseInt(values[0].substring(33, 36)));
            	onSetInterface(12, Integer.parseInt(values[0].substring(36, 39)));
            	onSetInterface(11, Integer.parseInt(values[0].substring(39, 42)));
            	onSetInterface(10, Integer.parseInt(values[0].substring(42, 45)));
            	
            	Toast ttoast = Toast.makeText(getApplicationContext(), "!", Toast.LENGTH_SHORT); 
    			ttoast.show();
    			mTcpClient.sending_enable = true;
    			Delay_sending("01", 1000);
            } else {
            	selectableParam = Integer.parseInt(values[0]); //    int
            	if (selectableParam == 6) { //    
            		if(mTcpClient != null) {
            			//disconnect
            			mTcpClient.stopClient();
            			mTcpClient = null;
            		}
            		finish();
            	}
            }
            /*
            if (selectableParam != 0) {   //        
            	mTcpClient.sending_enable = false;
            	dataParam = Integer.parseInt(values[0]); //    int
            	if (control_enable) {check_sum = check_sum + selectableParam + dataParam;}
            	
            	if (selectableParam == 5) {  //   
            		if (check_sum != dataParam) {
            			Toast toast = Toast.makeText(getApplicationContext(), " ...", Toast.LENGTH_SHORT); 
            			toast.show();
            			mTcpClient.sending_enable = true;
            			Delay_sending("03", 1000);
            		} else {
            			Toast toast = Toast.makeText(getApplicationContext(), "!", Toast.LENGTH_SHORT); 
            			toast.show();
            			mTcpClient.sending_enable = true;
            			Delay_sending("01", 1000);
            		}
            		check_sum = 0;
            		mTcpClient.sending_enable = false;
            	}
            	onSetInterface(selectableParam, dataParam);
            	selectableParam = 0;      // 
            	dataParam = 0;            //
            	mTcpClient.sending_enable = true;
            } else { //      values[0]       else ???!!!
            	selectableParam = Integer.parseInt(values[0]); //    int
            	
            	if (selectableParam == 4) { //       
            		control_enable = true;
            		check_sum = 0;
            		selectableParam = 0;
            		Toast toast = Toast.makeText(getApplicationContext(), "...", Toast.LENGTH_SHORT); 
        			toast.show();
            	}
            	
            	if (selectableParam == 5) { //         
            		                        // 
            		control_enable = false;
            	}
            	if (selectableParam == 6) { //    
            		if(mTcpClient != null) {
            			//disconnect
            			mTcpClient.stopClient();
            			mTcpClient = null;
            		}
            		finish();
            	}
            }
            */
        } 
    }
    
    //,    WIFI  ______________________________________
    
    private BroadcastReceiver WifiStateChangedReceiver = new BroadcastReceiver() {
		@Override
		public void onReceive(Context context, Intent intent) {
			// TODO Auto-generated method stub
			int extraWifiState = intent.getIntExtra(WifiManager.EXTRA_WIFI_STATE, WifiManager.WIFI_STATE_UNKNOWN);
			if (extraWifiState == WifiManager.WIFI_STATE_DISABLED) {wifiManager.setWifiEnabled(true);} // Wi-Fi,  
			if (extraWifiState == WifiManager.WIFI_STATE_ENABLED) { // Wi-Fi ,     
				extra_wifi_prof_recreate_need = true; //  ,            
				                                      //   
				registerReceiver(SupplicantStateChangedActionReceiver, new IntentFilter(WifiManager.SUPPLICANT_STATE_CHANGED_ACTION));
				Toast toast = Toast.makeText(getApplicationContext(), "  ~20", Toast.LENGTH_SHORT); 
			    toast.show();
			    if (extra_wifi_prof_recreate_need) {Extra_recreate_wifi_prof();}
			}
			
			/*
			switch (extraWifiState) {
			case WifiManager.WIFI_STATE_DISABLED:
				wifiManager.setWifiEnabled(true); //  Wi-Fi
				//tv.setText("WIFI ");
				break;
			case WifiManager.WIFI_STATE_DISABLING:
				//tv.setText("WIFI ");
				break;
			case WifiManager.WIFI_STATE_ENABLED:
				//tv.setText("WIFI ");
				break;
			case WifiManager.WIFI_STATE_ENABLING:
				//tv.setText("WIFI ");
				break;
			case WifiManager.WIFI_STATE_UNKNOWN:
				//tv.setText("WIFI:  ");
				break;
			}
			*/
		}
	};
	
	//,     ______________________________________
	
	private BroadcastReceiver SupplicantStateChangedActionReceiver = new BroadcastReceiver() {

		@Override
		public void onReceive(Context context, Intent intent) {
			// TODO Auto-generated method stub
			if (intent.getAction().equals(WifiManager.SUPPLICANT_STATE_CHANGED_ACTION)) {
	            SupplicantState state = (SupplicantState) intent.getParcelableExtra(WifiManager.EXTRA_NEW_STATE);
	            switch(state){
	            case COMPLETED:                   //    
	            	extra_wifi_prof_recreate_need = false; //    ,         
                                                           //      
	            	WifiInfo wifiInfo = wifiManager.getConnectionInfo();
	            	if (wifi_conf_first_time) {
	            		wifi_conf_first_time = false;
	            	    //wifiProfCreateDial.wprofconfirm_bt.setVisibility(Button.VISIBLE);
	        		    //wifiProfCreateDial.you_SSID.setText("   :  " + wifiInfo.getSSID());
	        		    target_SSID = wifiInfo.getSSID();
	        		    Wifiprof_confirm();
	            	} else {
					    if (wifiInfo.getSSID().equals(target_SSID)) {   //        
						    Toast toast = Toast.makeText(getApplicationContext(), "   !", Toast.LENGTH_SHORT); 
						    toast.show();
						    Timer timer = new Timer(); //           ( )
						    TimerTask delay_connect = new TimerTask() {

							    @Override
							    public void run() {
								    // TODO Auto-generated method stub
								    runOnUiThread(new Runnable() {
								    	
									    @Override
									    public void run() {
										    Toast toast = Toast.makeText(getApplicationContext(), " ...", Toast.LENGTH_SHORT); 
										    toast.show();
										    new ConnectTask().execute();
									    }
								    });
							    }
						    };
						    //if (timer != null) {timer.cancel();}
						    timer.schedule(delay_connect, 2000);
					    } else { //      
						    Toast toast = Toast.makeText(getApplicationContext(), " ...", Toast.LENGTH_SHORT); 
						    toast.show();
						    List<WifiConfiguration> netconfigurations = wifiManager.getConfiguredNetworks();
						    WifiConfiguration foundConfig=null;
						    for (WifiConfiguration config : netconfigurations) { //   ,  
							    if (config.SSID.equals("\"" + target_SSID + "\"")) {
								    foundConfig=config;
								    break;
							    }
						    }
						    if (foundConfig != null) {   //  , 
							    wifiManager.enableNetwork(foundConfig.networkId, true);
						    } else {
							    Toast toast = Toast.makeText(getApplicationContext(), "   !", Toast.LENGTH_SHORT); 
							    toast.show();
							         // ,     
							    Recreate_wifi_prof();
						    }
					    }
	            	}
	            	break;
	            case DISCONNECTED:
	            	break;
				default:
					break;    
	            }
	        }
		}
		
	};
	
	     //  _________________________________________________
	
	private SeekBar.OnSeekBarChangeListener volumeSeekBarChangeListener = new SeekBar.OnSeekBarChangeListener() {
		int volumeprogress = 0;
        int volumedata = 0;
		@Override
		public void onProgressChanged(SeekBar seekBar, int progress,
				boolean fromUser) {
			// TODO Auto-generated method stub
			volumeprogress = progress - 80;
			if (progress <= 80) {
			    volumedata = 96 - progress;
			} else {
				volumedata = progress - 80;
			}
			volume = volumedata;
			if (volumeprogress == (-80)) {
				parvolTextView.setText("   " + "mute");
			} else {
			    parvolTextView.setText("   " + volumeprogress + "dB");
			}
			if (volumedata < 10) {                          
				mTcpClient.sendMessage("100" + volumedata); //     (  
			} else {                                        //,   )
			    mTcpClient.sendMessage("10" + volumedata);  //     (  )
			}
		}

		@Override
		public void onStartTrackingTouch(SeekBar seekBar) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void onStopTrackingTouch(SeekBar seekBar) {
			// TODO Auto-generated method stub
		
		}   
		
	};
	
	       //   _________________________________________________
	
	private SeekBar.OnSeekBarChangeListener temhighSeekBarChangeListener = new SeekBar.OnSeekBarChangeListener() {
		
		int temhighprogress = 0;
		int temhighdata = 0;

		@Override
		public void onProgressChanged(SeekBar seekBar, int progress,
				boolean fromUser) {
			// TODO Auto-generated method stub
			temhighprogress = progress - 15;
			if (progress >= 15) {
				temhighdata = progress + 1;
			} else {
				temhighdata = 15 - progress;
			}
			treble = temhighdata;
			partemhighTextView.setText("   " + temhighprogress + "dB");
			Temhigh_Sending();
		}

		@Override
		public void onStartTrackingTouch(SeekBar seekBar) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void onStopTrackingTouch(SeekBar seekBar) {
			// TODO Auto-generated method stub
			
		}
		
	};
	
	        //   _________________________________________________
	
	private SeekBar.OnSeekBarChangeListener temmidSeekBarChangeListener = new SeekBar.OnSeekBarChangeListener() {
		
		int temmidprogress = 0;
		int temmiddata = 0;
		
		@Override
		public void onProgressChanged(SeekBar seekBar, int progress,
				boolean fromUser) {
			// TODO Auto-generated method stub
			temmidprogress = progress - 15;
			if (progress >= 15) {
				temmiddata = progress + 1;
			} else {
				temmiddata = 15 - progress;
			}
			partemmidTextView.setText("   " + temmidprogress + "dB");
			middle = temmiddata;
			Temmid_Sending();
		}
		
		@Override
		public void onStartTrackingTouch(SeekBar seekBar) {
			// TODO Auto-generated method stub
			
		}
		
		@Override
		public void onStopTrackingTouch(SeekBar seekBar) {
			// TODO Auto-generated method stub
			
		}
		
	};
	
	       //   _________________________________________________
	
	private SeekBar.OnSeekBarChangeListener temlowSeekBarChangeListener = new SeekBar.OnSeekBarChangeListener() {
		
		int temlowprogress = 0;
		int temlowdata = 0;
		
		@Override
		public void onProgressChanged(SeekBar seekBar, int progress,
				boolean fromUser) {
			// TODO Auto-generated method stub
			temlowprogress = progress - 15;
			if (progress >= 15) {
				temlowdata = progress + 1;
			} else {
				temlowdata = 15 - progress;
			}
			partemlowTextView.setText("   " + temlowprogress + "dB");
			bass = temlowdata;
			Temlow_Sending();
			
		}
		
		@Override
		public void onStartTrackingTouch(SeekBar seekBar) {
			// TODO Auto-generated method stub
			
		}
		
		@Override
		public void onStopTrackingTouch(SeekBar seekBar) {
			// TODO Auto-generated method stub
			
		}
			
	};
	
	        //  _____________________________________________
	
	private SeekBar.OnSeekBarChangeListener loudSeekBarChangeListener = new SeekBar.OnSeekBarChangeListener() {
		
		int loudprogress = 0;
		int louddata = 0;
		
		@Override
		public void onProgressChanged(SeekBar seekBar, int progress,
				boolean fromUser) {
			// TODO Auto-generated method stub
			loudprogress = progress - 15;
			louddata = 15 - progress;
			loudness = louddata;
			parloudTextView.setText("   " + loudprogress + "dB");
			Loud_Sending();
			
		}
		
		@Override
		public void onStartTrackingTouch(SeekBar seekBar) {
			// TODO Auto-generated method stub
			
		}
		
		@Override
		public void onStopTrackingTouch(SeekBar seekBar) {
			// TODO Auto-generated method stub
			
		}
		
	};
	
	       //   _____________________________________________
	
	private SeekBar.OnSeekBarChangeListener subSeekBarChangeListener = new SeekBar.OnSeekBarChangeListener() {
		
		int subprogress = 0;
		int subdata = 0;
		
		@Override
		public void onProgressChanged(SeekBar seekBar, int progress,
				boolean fromUser) {
			// TODO Auto-generated method stub
			subprogress = progress - 80;
			if (progress <= 80) {
			    subdata = 96 - progress;
			} else {
				subdata = progress - 80;
			}
			if (subprogress == (-80)) {
				parsubTextview.setText("   " + "mute");
			} else {
			    parsubTextview.setText("   " + subprogress + "dB");
			}
			subatt = subdata;
			Att_Sending(15, subdata);
		}
		
		@Override
		public void onStartTrackingTouch(SeekBar seekBar) {
			// TODO Auto-generated method stub
			
		}
		
		@Override
		public void onStopTrackingTouch(SeekBar seekBar) {
			// TODO Auto-generated method stub
			
		}
			
	};
	
	       //  "Treble Center Frequency"____________________________________ 
	
	private RadioGroup.OnCheckedChangeListener trecenfreRadioGroupOnCheckedChangeListener = new RadioGroup.OnCheckedChangeListener() {
		
		@Override
		public void onCheckedChanged(RadioGroup group, int checkedId) {
			// TODO Auto-generated method stub
			switch(checkedId) {
			case -1:
				break;
				
			case R.id.bt_cf_10:
				treCenFre = 0;
				break;
			
			case R.id.bt_cf_12:
				treCenFre = 32;
				break;
				
			case R.id.bt_cf_15:
				treCenFre = 64;
				break;
				
			case R.id.bt_cf_17:
				treCenFre = 96;
				break;
				
			default:
				break;
			}
			Temhigh_Sending();
		}
	};
	
	        //  "Middle Q-factor"__________________________________________
	
	private RadioGroup.OnCheckedChangeListener midQfacRadioGroupOnCheckedChangeListener = new RadioGroup.OnCheckedChangeListener() {
		
		@Override
		public void onCheckedChanged(RadioGroup group, int checkedId) {
			// TODO Auto-generated method stub
			switch(checkedId) {
			case -1:
				break;
				
			case R.id.bt_qmf_05:
				midQfac = 0;
				break;
			
			case R.id.bt_qmf_075:
				midQfac = 32;
				break;
				
			case R.id.bt_qmf_1:
				midQfac = 64;
				break;
				
			case R.id.bt_qmf_125:
				midQfac = 96;
				break;
				
			default:
				break;
			}
			Temmid_Sending();
		}
	};
	
	        //  "Bass Q-factor"__________________________________________
	
	private RadioGroup.OnCheckedChangeListener lowQfacRadioGroupOnCheckedChangeListener = new RadioGroup.OnCheckedChangeListener() {
		
		@Override
		public void onCheckedChanged(RadioGroup group, int checkedId) {
			// TODO Auto-generated method stub
			switch(checkedId) {
			case -1:
				break;
				
			case R.id.bt_qlf_1:
				lowQfac = 0;
				break;
			
			case R.id.bt_qlf_125:
				lowQfac = 32;
				break;
				
			case R.id.bt_qlf_15:
				lowQfac = 64;
				break;
				
			case R.id.bt_qlf_2:
				lowQfac = 96;
				break;
				
			default:
				break;
			}
			Temlow_Sending();
		}
	};
	
	        //    ______________________________
	
	private RadioGroup.OnCheckedChangeListener loucenfreRadioGroupOnCheckedChangeListener = new RadioGroup.OnCheckedChangeListener() {
		
		@Override
		public void onCheckedChanged(RadioGroup group, int checkedId) {
			// TODO Auto-generated method stub
			switch(checkedId) {
			case -1:
				break;
				
			case R.id.bt_cldf_flat:
				louCenFre = 0;
				break;
			
			case R.id.bt_cldf_400:
				louCenFre = 16;
				break;
				
			case R.id.bt_cldf_800:
				louCenFre = 32;
				break;
				
			case R.id.bt_cldf_2400:
				louCenFre = 48;
				break;
				
			default:
				break;
			}
			
			Loud_Sending();
			
		}
	};
	
	        //    __________________________________________
	
	private RadioGroup.OnCheckedChangeListener midcenfreRadioGroupOnCheckedChangeListener = new RadioGroup.OnCheckedChangeListener() {
		
		@Override
		public void onCheckedChanged(RadioGroup group, int checkedId) {
			// TODO Auto-generated method stub
			switch(checkedId) {
			case -1:
				break;
				
			case R.id.bt_cmf_500:
				midCenFre = 0;
				break;
			
			case R.id.bt_cmf_1000:
				midCenFre = 4;
				break;
				
			case R.id.bt_cmf_1500:
				midCenFre = 8;
				break;
				
			case R.id.bt_cmf_2500:
				midCenFre = 12;
				break;
				
			default:
				break;
			}
			Misc_Sending();
		}
	};
	
	        //    __________________________________________
	
	private RadioGroup.OnCheckedChangeListener lowcenfreRadioGroupOnCheckedChangeListener = new RadioGroup.OnCheckedChangeListener() {
		
		@Override
		public void onCheckedChanged(RadioGroup group, int checkedId) {
			// TODO Auto-generated method stub
			switch(checkedId) {
			case -1:
				break;
				
			case R.id.bt_clf_60:
				lowCenFre = 0;
				break;
			
			case R.id.bt_clf_80:
				lowCenFre = 16;
				break;
				
			case R.id.bt_clf_100:
				lowCenFre = 32;
				break;
				
			case R.id.bt_clf_200:
				lowCenFre = 48;
				break;
				
			default:
				break;
			}
			Misc_Sending();
		}
	};
	
	        //   ______________________________________
	
	private RadioGroup.OnCheckedChangeListener inpselRadioGroupOnCheckedChangeListener = new RadioGroup.OnCheckedChangeListener() {
		
		@Override
		public void onCheckedChanged(RadioGroup group, int checkedId) {
			// TODO Auto-generated method stub
			switch(checkedId) {
			case -1:
				break;
				
			case R.id.bt_inp1: //QD
				inpsel = 0;
				break;
			
			case R.id.bt_inp2: //SE1
				inpsel = 1;
				break;
				
			case R.id.bt_inp3: //SE2
				inpsel = 2;
				break;
				
			case R.id.bt_inp4: //SE3
				inpsel = 3;
				break;
				
			default:
				break;
			}
			Input_Sending();
		}
	};
	
	        //  "Bass DC Mode"____________________________________________
	
	private RadioGroup.OnCheckedChangeListener lowdcRadioGroupOnCheckedChangeListener = new RadioGroup.OnCheckedChangeListener() {
		
		@Override
		public void onCheckedChanged(RadioGroup group, int checkedId) {
			// TODO Auto-generated method stub
			switch(checkedId) {
			case -1:
				break;
				
			case R.id.bas_mod_DC:
				bassDC = 0;
				break;
			
			case R.id.bas_mod_normal:
				bassDC = 64;
				break;
				
			default:
				break;
			}
			Misc_Sending();
		}
	};
	
	        //     _____________________________
	
	private RadioGroup.OnCheckedChangeListener subcoRadioGroupOnCheckedChangeListener = new RadioGroup.OnCheckedChangeListener() {
		
		@Override
		public void onCheckedChanged(RadioGroup group, int checkedId) {
			// TODO Auto-generated method stub
			switch(checkedId) {
			case -1:
				break;
				
			case R.id.bt_sco_flat:
				subCutFre = 0;
				break;
			
			case R.id.bt_sco_80:
				subCutFre = 1;
				break;
				
			case R.id.bt_sco_120:
				subCutFre = 2;
				break;
				
			case R.id.bt_sco_160:
				subCutFre = 3;
				break;
				
			default:
				break;
			}
			Misc_Sending();
		}
	};
	
	        //  High Boost _____________________________________
	
	private CompoundButton.OnCheckedChangeListener boostToggleButtonOnCheckedChangeListener = new CompoundButton.OnCheckedChangeListener() {
		
		//int lodata = 0;
		
		@Override
		public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
			// TODO Auto-generated method stub
			if (isChecked) {
				highboost = 0;
			} else {
				highboost = 64;
			}
			
			Loud_Sending();
	
		}
	};
	 
	        //  " on/off"_______________________________________________
	
	private CompoundButton.OnCheckedChangeListener subToggleButtonOnCheckedChangeListener = new CompoundButton.OnCheckedChangeListener() {
		
		@Override
		public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
			// TODO Auto-generated method stub
			if (isChecked) {
				sub_enable = 1;
				mTcpClient.sendMessage("8247");
			} else {
				sub_enable = 0;
				mTcpClient.sendMessage("8255");
			}
		}
	};
	
	       
	        //        _____
	
	public void onAttClick(View view) {  
	    switch(view.getId()) { 
	    case  R.id.button_decRF:
	    	if (rfatt < 96) {
	    	    rfatt = Att_Dec(rfatt);
	    	    parRFTextview.setText(" " + Conv_dB(rfatt) + "dB");
	    	    Att_Sending(11, rfatt);
	    	}
			break;
			
	    case  R.id.button_decLF:
	    	if (lfatt < 96) {
	    	    lfatt = Att_Dec(lfatt);
	    	    parLFTextview.setText(" " + Conv_dB(lfatt) + "dB");
	    	    Att_Sending(12, lfatt);
	    	}
			break;
			
	    case  R.id.button_decRR:
	    	if (rratt < 96) {
	    	    rratt = Att_Dec(rratt);
	    	    parRRTextview.setText(" " + Conv_dB(rratt) + "dB");
	    	    Att_Sending(13, rratt);
	    	}
			break;
		
	    case  R.id.button_decLR:
	    	if (lratt < 96) {
	    	    lratt = Att_Dec(lratt);
	    	    parLRTextview.setText(" " + Conv_dB(lratt) + "dB");
	    	    Att_Sending(14, lratt);
	    	}
			break;
			
	    case  R.id.button_incRF:
	    	if (rfatt != 15) {
	    	    rfatt = Att_Inc(rfatt);
	    	    parRFTextview.setText(" " + Conv_dB(rfatt) + "dB");
	    	    Att_Sending(11, rfatt);
	    	}
			break;
			
	    case  R.id.button_incLF:
	    	if (lfatt != 15) {
	    	    lfatt = Att_Inc(lfatt);
	    	    parLFTextview.setText(" " + Conv_dB(lfatt) + "dB");
	    	    Att_Sending(12, lfatt);
	    	}
			break;
			
	    case  R.id.button_incRR:
	    	if (rratt != 15) {
	    	    rratt = Att_Inc(rratt);
	    	    parRRTextview.setText(" " + Conv_dB(rratt) + "dB");
	    	    Att_Sending(13, rratt);
	    	}
			break;
		
	    case  R.id.button_incLR:
	    	if (lratt != 15) {
	    	    lratt = Att_Inc(lratt);
	    	    parLRTextview.setText(" " + Conv_dB(lratt) + "dB");
	    	    Att_Sending(14, lratt);
	    	}
			break;		
	    }
	    
	}
	
	        //        _________
	
	public void onGainClick(View view) {
		switch(view.getId()) {
		case  R.id.button_dec_gain:
	    	if (gain > 0) {
	    	    gain = gain - 8;
	    	    pargainTextview.setText(" " + ConGain_dB(gain) + "dB");
	    	}
			break;
			
		case  R.id.button_inc_gain:
	    	if (gain < 120) {
	    	    gain = gain + 8;
	    	    pargainTextview.setText(" " + ConGain_dB(gain) + "dB");
	    	}
			break;	
		}
		Input_Sending();
	}
	
	        //    "MODE"    (2.0; pro; 4.1)
	
	public void onModeClick(View view) {
		mode++;
		if (mode > 3) {mode = 1;}
		Mode_Display();
		mTcpClient.sendMessage("16" + mode);
		if (mode == 3) {
			inpsel = 1;
			mTcpClient.sending_enable = false;
			inpselRadioGroup.check(R.id.bt_inp2);
			mTcpClient.sending_enable = true;
		}
	}
	
	        //    "MUTE"____________________________________________
	
	public void onMuteClick(View view) {
        Mute_Show();
        mTcpClient.sendMessage("17" + mute);
	}
	
	        //    "***"_____________________________________________
	
	public void onAddClick(View view) {
        Add_Show();
	}

} //end of class activity
